Package org.apache.tapestry5.services

# Class ComponentLibraryInfo

java.lang.Object
org.apache.tapestry5.services.ComponentLibraryInfo

All Implemented Interfaces:
  `Serializable`

public final class ComponentLibraryInfo extends Object implements Serializable
Class that encapsulates information about a component library, going beyond what a library mapping provides.

Since:
  5.4
See Also:
  - `LibraryMapping`
  - `ComponentLibraryInfo.SourceUrlResolver`
  - Serialized Form

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `ComponentLibraryInfo.DefaultSourceUrlResolver`
  Default `ComponentLibraryInfo.SourceUrlResolver` implementation.
  `static interface`
  `ComponentLibraryInfo.SourceUrlResolver`
  Interface that provides the source URL for a given `ComponentLibraryInfo`.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ComponentLibraryInfo()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getArtifactId()`
  Returns the component library's group id for dependency management tools like Maven and Gradle.
  `String`
  `getDependencyManagementInfoUrl()`
  Returns an URL decribing the dependency management information for this component library.
  `String`
  `getDescription()`
  Returns a description of the component library.
  `String`
  `getDocumentationUrl()`
  Returns the URL of the component library's documentation.
  `String`
  `getGroupId()`
  Returns the component library's group id for dependency management tools like Maven and Gradle.
  `String`
  `getHomepageUrl()`
  Returns the URL of the homepage of the component library.
  `String`
  `getIssueTrackerUrl()`
  Returns the URL of the component's library issue tracker.
  `String`
  `getJavadocUrl()`
  Returns the URL of the component library's JavaDoc URL.
  `String`
  `getJavadocUrl(String className)`
  Returns the JavaDoc URL for a given class or `null` if the root JavaDoc URL was not provided.
  `String`
  `getName()`
  Returns the actual name of the component library (not the identifier).
  `String`
  `getSourceBrowseUrl()`
  Returns the URL where the component library's source can be browsed.
  `String`
  `getSourceRootUrl()`
  Returns the URL where the root folder of component library's source can be found.
  `String`
  `getSourceUrl(String className)`
  Returns the URL where the source of this class can be found or `null` if not available.
  `List<String>`
  `getTags()`
  Returns the tags associated which describe this component library.
  `String`
  `getTapestryVersion()`
  Returns the Tapestry version used by this component library.
  `String`
  `getVersion()`
  Returns the component library version.
  `boolean`
  `isDependencyManagementInfoPresent()`
  Tells whether full dependency management info (group id, artifact id and version) are present.
  `boolean`
  `isPart(String logicalName)`
  Given a logical name, tells whether a given component, page or mixin is part of this component library.
  `void`
  `setArtifactId(String artifactId)`
  `void`
  `setDescription(String description)`
  `void`
  `setDocumentationUrl(String documentationUrl)`
  `void`
  `setGroupId(String groupId)`
  `void`
  `setHomepageUrl(String homepageUrl)`
  `void`
  `setIssueTrackerUrl(String issueTrackingUrl)`
  `void`
  `setJavadocUrl(String javadocUrl)`
  `void`
  `setLibraryMapping(LibraryMapping libraryMapping)`
  `void`
  `setName(String name)`
  `void`
  `setSourceBrowseUrl(String sourceBrowseUrl)`
  `void`
  `setSourceRootUrl(String sourceRootUrl)`
  `void`
  `setSourceUrlResolver(ComponentLibraryInfo.SourceUrlResolver sourceUrlResolver)`
  `void`
  `setTags(List<String> tags)`
  `void`
  `setTapestryVersion(String tapestryVersion)`
  `void`
  `setVersion(String version)`
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### ComponentLibraryInfo

    public ComponentLibraryInfo()

- ## Method Details

  - ### getName

    public String getName()
    Returns the actual name of the component library (not the identifier). For example, "Tapestry 5 Core Library".

  - ### getDescription

    public String getDescription()
    Returns a description of the component library. For example, "The set of components, pages and mixins provided by Tapestry out-of-the-box.".

  - ### getHomepageUrl

    public String getHomepageUrl()
    Returns the URL of the homepage of the component library. For example, "http://tapestry.apache.org".

  - ### getDocumentationUrl

    public String getDocumentationUrl()
    Returns the URL of the component library's documentation. For example, "http://tapestry.apache.org/documentation.html".

  - ### getSourceBrowseUrl

    public String getSourceBrowseUrl()
    Returns the URL where the component library's source can be browsed. For example, "https://git-wip-us.apache.org/repos/asf?p=tapestry-5.git;a=summary".

  - ### getSourceRootUrl

    public String getSourceRootUrl()
    Returns the URL where the root folder of component library's source can be found. For example, "https://git-wip-us.apache.org/repos/asf?p=tapestry-5.git;a=tree;f=tapestry-core/src/main/java/".

  - ### getIssueTrackerUrl

    public String getIssueTrackerUrl()
    Returns the URL of the component's library issue tracker. For example, "https://issues.apache.org/jira/browse/TAP5".

  - ### getJavadocUrl

    public String getJavadocUrl()
    Returns the URL of the component library's JavaDoc URL. For example, "http://tapestry.apache.org/current/apidocs/"

  - ### getGroupId

    public String getGroupId()
    Returns the component library's group id for dependency management tools like Maven and Gradle. For example, "org.apache.tapestry".
    See Also:
      - `artifactId`
      - `version`

  - ### getArtifactId

    public String getArtifactId()
    Returns the component library's group id for dependency management tools like Maven and Gradle. For example, "tapestry-core".
    See Also:
      - `groupId`
      - `version`

  - ### getVersion

    public String getVersion()
    Returns the component library version. For example, "5.4.0".
    See Also:
      - `artifactId`
      - `groupId`

  - ### getTapestryVersion

    public String getTapestryVersion()
    Returns the Tapestry version used by this component library. For example, "5.4.0".

  - ### getTags

    public List<String> getTags()
    Returns the tags associated which describe this component library. Use just lowercase letters, numbers and dashes.

  - ### getDependencyManagementInfoUrl

    public String getDependencyManagementInfoUrl()
    Returns an URL decribing the dependency management information for this component library.

  - ### setName

    public void setName(String name)

  - ### setDescription

    public void setDescription(String description)

  - ### setHomepageUrl

    public void setHomepageUrl(String homepageUrl)

  - ### setDocumentationUrl

    public void setDocumentationUrl(String documentationUrl)

  - ### setSourceBrowseUrl

    public void setSourceBrowseUrl(String sourceBrowseUrl)

  - ### setSourceRootUrl

    public void setSourceRootUrl(String sourceRootUrl)

  - ### setJavadocUrl

    public void setJavadocUrl(String javadocUrl)

  - ### setVersion

    public void setVersion(String version)

  - ### setTapestryVersion

    public void setTapestryVersion(String tapestryVersion)

  - ### setGroupId

    public void setGroupId(String groupId)

  - ### setArtifactId

    public void setArtifactId(String artifactId)

  - ### setIssueTrackerUrl

    public void setIssueTrackerUrl(String issueTrackingUrl)

  - ### setTags

    public void setTags(List<String> tags)

  - ### setLibraryMapping

    public void setLibraryMapping(LibraryMapping libraryMapping)

  - ### setSourceUrlResolver

    public void setSourceUrlResolver(ComponentLibraryInfo.SourceUrlResolver sourceUrlResolver)

  - ### isDependencyManagementInfoPresent

    public boolean isDependencyManagementInfoPresent()
    Tells whether full dependency management info (group id, artifact id and version) are present.

  - ### isPart

    public boolean isPart(String logicalName)
    Given a logical name, tells whether a given component, page or mixin is part of this component library.

  - ### getJavadocUrl

    public String getJavadocUrl(String className)
    Returns the JavaDoc URL for a given class or `null` if the root JavaDoc URL was not provided.
    Parameters:
      `className` - the fully qualified class name.

  - ### getSourceUrl

    public String getSourceUrl(String className)
    Returns the URL where the source of this class can be found or `null` if not available. This implementation delegates to `ComponentLibraryInfo.SourceUrlResolver` if set.
    Parameters:
      `className` - the fully qualified class name.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`